package com.contextspace.objectdb_example.model;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.jdo.annotations.Index;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlTransient;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


@Entity
@Table
public class OtherObject extends IDHolder {
	private static final long serialVersionUID = 6789661029535292158L;
	
	static Logger log = LoggerFactory.getLogger(OtherObject.class.getName());
	
	private String name = null;
	
	private Map<String, String> someValues = new HashMap<String, String>();
	private List<String> someOtherValues = new ArrayList<String>();
	
	
	/**
	 * Default constructor for DB loading.
	 */
	public OtherObject() {
		super();
	}
	
	
	/**
	 * Creates the name using the name.
	 * @param name
	 */
	public OtherObject(String name) {
		super();
		this.name = name;
	}
	
	/**
	 * @return the name
	 */
	@Index
	public String getName() {
		return name;
	}


	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}


	/**
	 * @return the displayValues
	 */
	@OneToMany(cascade=CascadeType.ALL, fetch=FetchType.EAGER, orphanRemoval=true)
	public Map<String, String> getSomeValues() {
		return someValues;
	}

	/**
	 * @param someValues
	 */
	public void setSomeValues(Map<String, String> someValues) {
		this.someValues = someValues;
	}
	
	

    /**
     * @return the someOtherValues
     */
	@OneToMany(fetch = FetchType.EAGER, cascade=CascadeType.ALL)
    public List<String> getSomeOtherValues() {
        return someOtherValues;
    }


    /**
     * @param someOtherValues the someOtherValues to set
     */
    public void setSomeOtherValues(List<String> someOtherValues) {
        this.someOtherValues = someOtherValues;
    }


    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        StringBuffer buf = new StringBuffer();
        
        buf.append("<otherobject name=\"").append(name).append("\"");
        if(getId() > 0) {
            buf.append(" id=\"").append(getId()).append("\"");
        }
        buf.append(">");
        
        if(!someValues.isEmpty()) {
            buf.append("<somevalues>");
            for(Iterator<String> i = someValues.keySet().iterator(); i.hasNext();) {
                String key = i.next();
                String value = someValues.get(key);
                buf.append("<value key=\"").append(key).append("\" value=\"").append(value).append("\"/>");
            }
            buf.append("</somevalues>");
        }
        
        if(!someOtherValues.isEmpty()) {
            buf.append("<someothervalues>");
            for(Iterator<String> i = someOtherValues.iterator(); i.hasNext();) {
                String value = i.next();
                buf.append("<value value=\"").append(value).append("\"/>");
            }
            buf.append("</someothervalues>");
        }
        buf.append("</otherobject>");
        return buf.toString();
    }
}
